马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。
您需要 登录 才可以下载或查看,没有账号?立即注册
×
今日主要总结一下动态规划的一道题目,115. 差别的子序列
题目:115. 差别的子序列
Leetcode题目地址
题目描述:
给定一个字符串 s 和一个字符串 t ,盘算在 s 的子序列中 t 出现的个数。
字符串的一个 子序列 是指,通过删除一些(也可以不删除)字符且不干扰剩余字符相对位置所组成的新字符串。(例如,“ACE” 是 “ABCDE” 的一个子序列,而 “AEC” 不是)
题目数据保证答案符合 32 位带符号整数范围。
示例 1:
输入:s = “rabbbit”, t = “rabbit”
输出:3
解释:
如下图所示, 有 3 种可以从 s 中得到 “rabbit” 的方案。
rabbbit
rabbbit
rabbbit
示例 2:
输入:s = “babgbag”, t = “bag”
输出:5
解释:
如下图所示, 有 5 种可以从 s 中得到 “bag” 的方案。
babgbag
babgbag
babgbag
babgbag
babgbag
提示:
0 <= s.length, t.length <= 1000
s 和 t 由英文字母组成
本题重难点
这道题目假如不是子序列,而是要求连续序列的,那就可以考虑用KMP。
这道题目相对于72. 编辑距离,简朴了不少,因为本题相当于只有删除操作,不消考虑替换增加之类的。
但相对于刚讲过的动态规划:一文搞懂动态规划之392. 判断子序列题目就有难度了,这道题目双指针法可就做不了了,来看看动规五部曲分析如下:
- 确定dp数组(dp table)以及下标的寄义
dp[j]:以i-1为结尾的s子序列中出现以j-1为结尾的t的个数为dp[j]。
- 确定递推公式
这一类题目,基本是要分析两种情况
s[i - 1] 与 t[j - 1]相称
s[i - 1] 与 t[j - 1] 不相称
当s[i - 1] 与 t[j - 1]相称时,dp[j]可以有两部分组成。
一部分是用s[i - 1]来匹配,那么个数为dp[i - 1][j - 1]。
一部分是不消s[i - 1]来匹配,个数为dp[i - 1][j]。
这里可能有同学不明确了,为什么还要考虑 不消s[i - 1]来匹配,都相同了指定要匹配啊。
例如: s:bagg 和 t:bag ,s[3] 和 t[2]是相同的,但是字符串s也可以不消s[3]来匹配,即用s[0]s[1]s[2]组成的bag。
当然也可以用s[3]来匹配,即:s[0]s[1]s[3]组成的bag。
所以当s[i - 1] 与 t[j - 1]相称时,dp[j] = dp[i - 1][j - 1] + dp[i - 1][j];
当s[i - 1] 与 t[j - 1]不相称时,dp[j]只有一部分组成,不消s[i - 1]来匹配,即:dp[i - 1][j]
所以递推公式为:dp[j] = dp[i - 1][j];
- dp数组如何初始化
从递推公式dp[j] = dp[i - 1][j - 1] + dp[i - 1][j]; 和 dp[j] = dp[i - 1][j]; 中可以看出dp[0] 和dp[0][j]是一定要初始化的。
每次当初始化的时间,都要回首一下dp[j]的界说,不要凭感觉初始化。
dp[0]表示什么呢?
dp[0] 表示:以i-1为结尾的s可以任意删除元素,出现空字符串的个数。
那么dp[0]一定都是1,因为也就是把以i-1为结尾的s,删除全部元素,出现空字符串的个数就是1。
再来看dp[0][j],dp[0][j]:空字符串s可以任意删除元素,出现以j-1为结尾的字符串t的个数。
那么dp[0][j]一定都是0,s如论如何也酿成不了t。
末了就要看一个特别位置了,即:dp[0][0] 应该是多少。
dp[0][0]应该是1,空字符串s,可以删除0个元素,酿成空字符串t。
- 确定遍历顺序
从递推公式dp[j] = dp[i - 1][j - 1] + dp[i - 1][j]; 和 dp[j] = dp[i - 1][j]; 中可以看出dp[j]都是根据左上方和正上方推出来的。
所以遍历的时间一定是从上到下,从左到右,这样保证dp[j]可以根据之前盘算出来的数值进行盘算。
以s:“baegg”,t:"bag"为例,推导dp数组状态如下:
假如写出来的代码怎么改都通过不了,不妨把dp数组打印出来,看一看,是不是这样的。
C++代码
- class Solution {
- public:
- int numDistinct(string s, string t) {
- vector<vector<uint64_t>>dp(s.size() + 1, vector<uint64_t>(t.size() + 1, 0));
- for(int i = 0; i <= s.size(); i++) dp[i][0] = 1;
- for (int i = 1; i <= s.size(); i++){
- for(int j = 1; j <= t.size(); j++){
- if(s[i - 1] == t[j - 1]){
- dp[i][j] = dp[i - 1][j - 1] + dp[i - 1][j];
- }
- else{
- dp[i][j] = dp[i - 1][j];
- }
- }
- }
- return dp[s.size()][t.size()];
- }
- };
复制代码 总结
动态规划
英文:Dynamic Programming,简称DP,假如某一题目有很多重叠子题目,利用动态规划是最有用的。
动态规划中每一个状态一定是由上一个状态推导出来的,这一点就区分于贪婪,贪婪没有状态推导,而是从局部直接选最优的
对于动态规划题目,可以拆解为如下五步曲,这五步都搞清楚了,才气说把动态规划真的把握了!
- 确定dp数组(dp table)以及下标的寄义
- 确定递推公式
- dp数组如何初始化
- 确定遍历顺序
- 举例推导dp数组
这道题目假如不是子序列,而是要求连续序列的,那就可以考虑用KMP。
这道题目相对于72. 编辑距离,简朴了不少,因为本题相当于只有删除操作,不消考虑替换增加之类的。
但相对于刚讲过的动态规划:一文搞懂动态规划之392. 判断子序列题目就有难度了,动态规划中依然是利用动规五部曲,做每道动态规划题目这五步都要弄清楚才气更清楚的理解题目!
(关注后可以免费获得本人在csdn发布的资源源码)
|